//========================================================================================================================================
//GAME SCREEN 

//initial start functions needed for the game screen

void started()
{
  dealt = false;
  dealCardNum = 0; //to keep track of which card is being dealt;

  //variables needed while playing
  round = 1; //game consists of total 13 rounds (each player has 13 cards)
  turn = 1; //to keep track which player's turn it is
  firstTurn = 1; //to keep track of which player has to start round - no restriction on playing the card
  p1trick = 0; //to keep track of the number of tricks made by player 1
  p2trick = 0; //to keep track of the number of tricks made by player 2
  prevCard1 = 100; //to keep track of the previous card so that it can move to the tricks area
  prevCard2 = 100; //to keep track of the previous card so that it can move to the tricks area
  won = 0;
  counter = 0;
  delay = false;
  pause = true;
  cheer = false;

  //ctr = new int[26];
  for (int i=0; i<26; i++)
    ctr[i]=0;

  for (int j=1; j<=52; j++) 
  {
    cards[j].dealt = false;
    cards[j].visible = false;
    cards[j].played = false;
  }
  deal(); //logically dealing cards

  //start = true;
}

//========================================================================================================================================

void theme()
{ 
  //background - red texture
  //image(bg, width/2, height/2, width, height);
  //display the table
  pushStyle();
  strokeWeight(10);
  fill(0);
  stroke(0, 120, 70);
  rect(width/2, height/2, tableW, tableH);
  popStyle();
  image(table, width/2, height/2, tableW, tableH);

  //displaying deck cards
  //for (int i = 0; i<26; i++)
  image(cards[0].cImg, marginX/2, height/2, deckW, deckW/691*1056);
  pushStyle();
  fill(255, 255, 0);
  textSize(18);
  text("Deck", marginX/2, height/2-deckW/691*1056*1.2/2);
  popStyle();

  //displaying other placeholders
  //on the playing table
  pushStyle();
  fill(0, 0, 0, 160);
  rect(p1X, height/2, deckW, deckW/691*1056);
  rect(p2X, height/2, deckW, deckW/691*1056);
  fill(255, 255, 0);
  textSize(16);
  if (round<=13)
  {
    text("Player 1 Card", p1X, height/2-deckW/691*1056*1.2/2);
    text("Player 2 Card", p2X, height/2-deckW/691*1056*1.2/2);
  }
  //for the tricks made
  fill(0, 0, 0, 160);
  rect(width-marginX/2, t1Y, tCardH, tCardW);
  rect(width-marginX/2, t2Y, tCardH, tCardW);
  fill(255, 255, 0);
  textSize(14);
  text("Player 1 Tricks", width-marginX/2, height-marginY);
  text("Player 2 Tricks", width-marginX/2, marginY);
  popStyle();

  //home button
  image(home, homeW*0.9, homeW*0.9, homeW, homeW);
}


//========================================================================================================================================
//the main game screen

void gameScreen()
{  
  if (!start)
  {
    started();
    start = true;
  } else
  { 
    theme();

    //physically dealing cards
    if (!dealt)
    {
      //sounds[0].play();
      if (millis() >= m2 + 500) //start dealing after some pause
      {
        for (int i=0; i<26; i++)
          if (ctr[i]>dealIncNum) //to display the card there once dealt (i.e. position taken)
            if (i%2==0)
              image(cards[0].cImg, marginX/2+cardW/2+i/2*cardW, height-marginY/2, cardW, cardW/691*1056);
            else
              image(cards[0].cImg, marginX/2+cardW/2+i/2*cardW, marginY/2, cardW, cardW/691*1056);
        if (dealCardNum%2 == 0)
          dealCards(marginX/2+cardW/2+dealCardNum/2*cardW, height-marginY/2);
        else 
        dealCards(marginX/2+cardW/2+dealCardNum/2*cardW, marginY/2);
        if (dealCardNum >= 26)
        {
          dealt = true;
          sounds[1].play();
        }
      }
    } 

    //start game after dealing cards
    else 
    { 

      //display all the cards in their respective places
      for (int i=1; i<=52; i++)
        if (cards[i].visible)
          image(cards[i].cImg, cards[i].posX, cards[i].posY, cardW, cardW/691*1056);


      if (round<=13)
      {
        pushStyle();
        textAlign(LEFT);
        if (!pause)
          text("Round: " + (round-1), marginX*1.1, marginY*1.2);
        else 
        {
          text("Round: " + round, marginX*1.1, marginY*1.2);
          //if (roundBeep == true)
          //{
          //  sounds[3].play();
          //  roundBeep = false;
          //}
        }
        popStyle();
      }

      //assign whose trurn it is for every round

      //hide both player cards when tricks are being collected
      if (!pause)
      {
        //hide player 1 cards
        for (int i=0; i<13; i++)
        {
          if (!cards[p1Hand[i]].played) //if the card has not been played, hide it
            image(cards[0].cImg, marginX/2+cardW/2+i*cardW, height-marginY/2, cardW, cardW/691*1056);
        }
        //hide player 2 cards
        for (int i=0; i<13; i++)
        {
          if (!cards[p2Hand[i]].played) //if the card has not been played, hide it
            image(cards[0].cImg, marginX/2+cardW/2+i*cardW, marginY/2, cardW, cardW/691*1056);
        }
      }


      //play cards in the center
      //if it is Player 1's turn
      if (turn == 1 && pause)
      {
        //hide player 2 cards
        for (int i=0; i<13; i++)
        {
          if (!cards[p2Hand[i]].played) //if the card has not been played, hide it
            image(cards[0].cImg, marginX/2+cardW/2+i*cardW, marginY/2, cardW, cardW/691*1056);
        }

        if (round<=13)
        {
          pushStyle();
          textSize(20);
          text("Player 1 has to play", width/2, height-marginY*1.2);
          popStyle();
        }
        if (firstTurn == 1) //player 1 is starting the round
        {
          if (mouseX<width-marginX/2 && mouseX>marginX/2 && 
            mouseY<height-marginY/2+cardW/691*1056/2 && mouseY>height-marginY/2-cardW/691*1056/2 
            && mousePressed) 
          {
            //background(255);
            cardPlayed = int((mouseX-marginX/2)/cardW);
            if (!cards[p1Hand[cardPlayed]].played) //to check if where the player clicked, the card there has been played or not already
            {
              card1Played = p1Hand[cardPlayed];
              cards[card1Played].posX=p1X;
              cards[card1Played].posY=height/2;
              cards[card1Played].played = true;
              turn=2; //player 2's turn now
              sounds[1].play();
              //image(cards[p1Hand[cardPlayed]].cImg, cards[p1Hand[cardPlayed]].posX, cards[p1Hand[cardPlayed]].posY, cardW, cardW/691*1056);
            }
          }
        } else //if the player is second to play in this round
        {
          if (mouseX<width-marginX/2 && mouseX>marginX/2 && 
            mouseY<height-marginY/2+cardW/691*1056/2 && mouseY>height-marginY/2-cardW/691*1056/2 
            && mousePressed) 
          {
            cardPlayed = int((mouseX-marginX/2)/cardW); //gives index of card in hand not cards array
            if (!cards[p1Hand[cardPlayed]].played) //to check if where the player clicked, the card there has been played or not already
            {
              card2Played = p1Hand[cardPlayed];
              if (check(p1Hand[cardPlayed], p1Hand)) //to check if the card played is correct or not;
              {
                //updating position of the card
                cards[p1Hand[cardPlayed]].posX=p1X;
                cards[p1Hand[cardPlayed]].posY=height/2;
                cards[p1Hand[cardPlayed]].played = true;

                if (pause == true)
                {
                  m = millis();
                  //println(m);
                  pause = false;
                }

                //see who won the trick
                trick(p1Hand[cardPlayed], 1);
                round++;
                sounds[1].play();

                prevCard1 = p1Hand[cardPlayed]; //card played by player 1
                prevCard2 = card1Played; //card played by player 2
              }
            }
          }
        }
      }

      if (turn == 2 && pause)
      {
        //hide player 1 cards
        for (int i=0; i<13; i++)
        {
          if (!cards[p1Hand[i]].played) //if the card has not been played, hide it
            image(cards[0].cImg, marginX/2+cardW/2+i*cardW, height-marginY/2, cardW, cardW/691*1056);
        }

        if (round<=13)
        {
          pushStyle();
          textSize(20);
          text("Player 2 has to play", width/2, height-marginY*1.2);
          popStyle();
        }
        if (firstTurn == 2) //player 2 is starting the round
        {
          if (mouseX<width-marginX/2 && mouseX>marginX/2 && 
            mouseY<marginY/2+cardW/691*1056/2 && mouseY>marginY/2-cardW/691*1056/2 
            && mousePressed) 
          { 
            cardPlayed = int((mouseX-marginX/2)/cardW); //gives index of card in hand not cards array
            if (!cards[p2Hand[cardPlayed]].played)
            {
              card1Played = p2Hand[cardPlayed];
              cards[card1Played].posX=p2X;
              cards[card1Played].posY=height/2;
              cards[card1Played].played = true;
              turn=1; //player 2's turn now
              sounds[1].play();
            }
          }
        } else //if the player is second to play in this round
        {
          //soundBeep =true;
          if (mouseX<width-marginX/2 && mouseX>marginX/2 && 
            mouseY<marginY/2+cardW/691*1056/2 && mouseY>marginY/2-cardW/691*1056/2 
            && mousePressed)
          {
            cardPlayed = int((mouseX-marginX/2)/cardW); //gives index of card in hand not cards array
            if (!cards[p2Hand[cardPlayed]].played) //to check if where the player clicked, the card there has been played or not already
            {
              if (check(p2Hand[cardPlayed], p2Hand)) //to check if the card played is correct or not;
              {
                //updating position of the card
                cards[p2Hand[cardPlayed]].posX=p2X;
                cards[p2Hand[cardPlayed]].posY=height/2;
                cards[p2Hand[cardPlayed]].played = true;

                //to make cards invisible after sometime they've been played
                if (pause == true)
                {
                  m = millis();
                  //println(m);
                  pause = false;
                }

                trick(p2Hand[cardPlayed], 2);

                round++;
                sounds[1].play();

                prevCard1 = card1Played; //player 1 card
                prevCard2 = p2Hand[cardPlayed]; //player 2 card

                //delay(2000);
                //delay = true;

                //cards[card1Played].visible = false;
                //cards[p2Hand[cardPlayed]].visible = false;
                //made them invisible after the trick is collected
              }
            }
          }
        }
      }

      //adding delay before the trick is collected
      //println(millis());
      if (millis() >= m + 2500) //if current time has been delyed by 2.5sec
      {
        //make the previous cards move
        if (prevCard1!=100)
        {
          if (counter == 0)
            sounds[2].play();
          if (counter<trickIncNum)
          {
            if (won == 1)
            {
              finalY = t1Y; 
              finalX = width-marginX/2;
              incX1 = (finalX-p1X)/trickIncNum;
              incX2 = (finalX-p2X)/trickIncNum;
              incY = (finalY - height/2)/trickIncNum; //this is the increment for each step
              cards[prevCard1].posX += incX1; 
              cards[prevCard1].posY += incY;
              cards[prevCard2].posX += incX2; 
              cards[prevCard2].posY += incY;
              counter++;
            } else if (won == 2)
            {
              finalY = t2Y; 
              finalX = width-marginX/2;
              incX1 = (finalX-p1X)/trickIncNum;
              incX2 = (finalX-p2X)/trickIncNum;
              incY = (finalY - height/2)/trickIncNum; //this is the increment for each step
              cards[prevCard1].posX += incX1; 
              cards[prevCard1].posY += incY;
              cards[prevCard2].posX += incX2; 
              cards[prevCard2].posY += incY;
              counter++;
            }
          } else 
          {
            counter=0;
            cards[prevCard1].visible = false;
            cards[prevCard2].visible = false;
            prevCard1 = 100;
            pause = true;
          }
        }
        //pause = true;
      }

      //updating the trick count
      pushStyle();
      fill(255, 255, 0);
      textSize(18);
      if (!pause && won == 1)
        text(p1trick-1, width-marginX/2, t1Y);
      else
        text(p1trick, width-marginX/2, t1Y);
      if (!pause && won == 2)
        text(p2trick-1, width-marginX/2, t2Y);
      else
        text(p2trick, width-marginX/2, t2Y);
      popStyle();

      //if (delay)
      //{
      //  delay(2000);
      //  delay = false;
      //}

      if (round>13 && pause)
      {
        //text("Round: - ", marginX*1.25, marginY*1.15);
        endScreen();

        //start = false;
      }
    }
  }

  //hover over home button
  if (mouseX>homeW*0.9-homeW/2 && mouseX<homeW*0.9+homeW/2 && mouseY>homeW*0.9-homeW/2 && mouseY<homeW*0.9+homeW/2)
  {
    tint(0, 0, 0, 70);
    image(home, homeW*0.9, homeW*0.9, homeW, homeW);
    noTint();
  }
}


//========================================================================================================================================
//OTHER FUNCTIONS NEEDDED FOR THE GAME SCREEN 

//required for the physical dealing of cards
void dealCards(float x, float y)
{
  if (ctr[dealCardNum]<=dealIncNum)
  {
    if (ctr[dealCardNum] == 0)
      sounds[0].play();
    float incrementX = (x-deckPosX)/dealIncNum;
    float incrementY = (y-deckPosY)/dealIncNum;
    float incrementDeckW = (cardW-deckW)/dealIncNum;
    image(cards[0].cImg, deckPosX+ctr[dealCardNum]*incrementX, 
      deckPosY+ctr[dealCardNum]*incrementY, 
      deckW+ctr[dealCardNum]*incrementDeckW, 
      (deckW+ctr[dealCardNum]*incrementDeckW)/691*1056);
    ctr[dealCardNum]++;
  } else
  {
    //image(cards[0].cImg, x, y, cardW, cardW/691*1056);
    dealCardNum++;
    //sounds[0].play();
  }
}


//required for sorting the cards in hand
void sortCards(int[] hand) //using bubble sort - I know this from my prev CS course
{
  int n = hand.length;
  for (int i = 0; i < n - 1; i++) 
  {
    for (int j = 0; j < n - i - 1; j++) 
    {
      if (hand[j] > hand[j+1]) 
      {
        //swap the elements
        int temp = hand[j];
        hand[j] = hand[j+1];
        hand[j+1] = temp;
      }
    }
  }
}


//to check if the second card played is correct or not
boolean check(int index, int[] hand)
{
  if (cards[index].suit == cards[card1Played].suit)
    return true; //correct card has been played
  else
  {
    //first check if there are cards of this suit
    for (int i=0; i<13; i++)
      if (cards[hand[i]].suit == cards[card1Played].suit && !cards[hand[i]].played) //found a card of same suit
      {
        text("You must play a card of the same suit", width/2, marginY*1.1);   
        if (!sounds[5].isPlaying())
          sounds[5].play(); 
        //if (soundBeep == true)
        //{
        //  sounds[5].play();
        //  soundBeep = false;
        //}
        //didnt use this idea here because I want to loop the sound
        return false;
      }
    return true;
  }
}


//to see who made the traick once both cards have been played
void trick(int card2, int player)
{
  //int x;
  int card1 = card1Played;
  if (cards[card1].suit == cards[card2].suit)
  {
    if (card2 > card1)
    {
      if (player == 1) //first player played a greater card
      {
        p1trick++;
        won = firstTurn = turn = 1;
      } else 
      {
        p2trick++;
        won = firstTurn = turn = 2;
      }
    } else //if the second card played is smaller
    {
      if (player == 1) //first player played a greater card
      {
        p2trick++;
        won = firstTurn = turn = 2;
      } else 
      {
        p1trick++;
        won = firstTurn = turn = 1;
      }
    }
  } else
  {
    if (player == 1)
    {
      p2trick++;
      won = firstTurn = turn = 2;
    } else
    {
      p1trick++;
      won = firstTurn = turn = 1;
    }
  }
  //return x;
}


//for logically dealing cards i.e. assigning cards to each player 
void deal()
{
  int cid;
  for (int i=0; i<13; i++)
  {
    do {
      cid = int(random(52))+1;
    } while (cards[cid].dealt);
    if (!cards[cid].dealt)
    {
      cards[cid].dealt = true;
      p1Hand[i]=cid; //player 1 has been assigned/dealt this card
      //println(cid);
    }

    do {
      cid = int(random(52))+1;
    } while (cards[cid].dealt);
    if (!cards[cid].dealt)
    {
      cards[cid].dealt = true;
      p2Hand[i]=cid; //player 2 has been assigned/dealt this card
      //println(cid);
    }
  }

  //sort the cards in hand - because you cannot play until you arrange cards properly
  sortCards(p1Hand);
  sortCards(p2Hand);

  //displaying hand cards for player 1 that have been assigned/dealt
  int j;
  for (int i = 0; i<13; i++) {
    j = p1Hand[i];
    //update position in the class attribute for those cards
    cards[j].posX = marginX/2+cardW/2+i*cardW;
    cards[j].posY = height-marginY/2;
    cards[j].visible = true;
  }
  //displaying hand cards for player 2 that have been assigned/dealt
  for (int i = 0; i<13; i++) {
    j = p2Hand[i];
    //update position in the class attribute for those cards
    cards[j].posX = marginX/2+cardW/2+i*cardW;
    cards[j].posY = marginY/2;
    cards[j].visible = true;
    //image(cards[j].cImg, cards[j].posX, cards[j].posY, cardW, cardW/691*1056);
  }
}


//for the end screen - which is a part of the game screen
void endScreen()
{
  //displaying the congratulations message
  pushStyle();
  //fill(255, 255, 0);
  textFont(font);
  fill(255, 255, 0);
  text("GAME OVER", width/2, marginY/2);
  textSize(48);
  fill(255);
  if (p1trick > p2trick)
    text("Player 1 has Won", width/2, height/2-40);
  else
    text("Player 2 has Won", width/2, height/2-40);
  textSize(40);
  text("Congratulations!", width/2, height/2+30);
  popStyle();

  //cheering sound
  //if (!sounds[4].isPlaying())
  //  sounds[4].play();
  //didnt use this idea here because i do not want the sound to loop
  if (cheer == false)
  {
    sounds[4].play();
    cheer = true;
  }

  //button to restart
  pushStyle();
  fill(255, 200, 1);
  strokeWeight(2);
  stroke(225, 173, 1);
  rect(width/2, height-marginY/2, marginX*0.8, marginY*0.3, 10);
  textSize(16);
  fill(0);
  text("Play Again", width/2, height-marginY/2);
  popStyle();

  //hover over restart button
  if (mouseX<width/2+marginX*0.8/2 && mouseX>width/2-marginX*0.8/2
    && mouseY<height-marginY/2+marginY*0.3/2 && mouseY>height-marginY/2-marginY*0.3/2)
  {
    pushStyle();
    fill(225, 173, 1); //change color on hover
    stroke(225, 173, 1);
    strokeWeight(2);
    rect(width/2, height-marginY/2, marginX*0.8, marginY*0.3, 10);
    textSize(18);
    fill(50);
    text("Play Again", width/2, height-marginY/2);
    //if (mousePressed)
    //{
    //  start = false;
    //  sounds[4].stop(); //stop playing the cheering sound even if it hasnt finished -- do same when click on home button
    //} 
    //changed this to click function so that it works on a tap
    popStyle();
  }
}
